#include "config.h"

#include "global_options.hpp"

#include "config.hpp"

#include "gettext.hpp"

#include <string>
#include <vector>

#include <iostream>

#include <cassert>

using std::string;
using std::vector;

GlobalOptions::GlobalOptions()
{
  Config *conf = S_Config::get_instance();

  vector<string> dir_order_values;
  dir_order_values.push_back(gettext("directories first"));
  dir_order_values.push_back(gettext("by name"));

  vector<string> english_dir_order_values;
  english_dir_order_values.push_back("directories first");
  english_dir_order_values.push_back("by name");

  dir_order = new Option(false, gettext("sorting"), "sorting",
			 0, dir_order_values, english_dir_order_values);

  vector<string> cd_device_values;

  assert(conf->p_cdpath().size() == conf->p_cdname().size());

  std::list<std::pair<string, string> > cd_names = conf->p_cdname();

  for (std::list<std::pair<string, string> >::const_iterator iter = cd_names.begin(); 
       iter != cd_names.end(); ++iter)
    cd_device_values.push_back(iter->second);

  cd_device = new Option(false, gettext("cd device"), "cd device",
			 0, cd_device_values, cd_device_values);

  vector<string> audio_device_values;
  audio_device_values.push_back(conf->p_first_dev_name());

  if (!conf->p_second_dev_name().empty())
    audio_device_values.push_back(conf->p_second_dev_name());

  audio_device = new Option(false, gettext("audio device"), "audio device",
			    0, audio_device_values, audio_device_values);
}

GlobalOptions::~GlobalOptions()
{
  delete dir_order;
  delete cd_device;
  delete audio_device;
}
