#ifndef SIMPLE_AUDIO_HPP
#define SIMPLE_AUDIO_HPP

#include "audio.hpp"

class SimpleAudio : public AudioTemplate<Simplefile>
{
private:
  // audio add specific
  void enter_dir();

  void secondary_menu_in_add(ExtraMenu &em);

  void secondary_menu();

  void add_file_to_list(std::vector<Simplefile>& list, const Simplefile& el)
  {
    list.push_back(el);
  }

  // add an audio dir recursively (all the files in it) to the playlist
  std::vector<Simplefile> add_dir(const std::string& dir, bool from_media = false);
  // read a dir and spit out a list of files and dirs
  std::vector<Simplefile> rdir(const std::string& argv);

  void print_element(const Simplefile& r, const Simplefile& position, int y);

  void intelligent_random_prev() 
  {}
  void intelligent_random_next()
  {}

  void options_reloaded()
  {}

  void print_audiotrack_helper(int &x_pos, std::string& buffer, 
			       std::string& album, std::string& artist, std::string& title);
  
  void print_audio_screensaver_helper(int &x_pos, int &y, int max_x_pic, int max_y_pic) 
  { x_pos = 100; }

  void search_func()
  {
    BusyIndicator::get_instance().idle();

    ConstFunctor<SimpleAudio, Simplefile, bool> compare_func(this, &SimpleAudio::search_compare);
    ConstFunctor<SimpleAudio, std::vector<Simplefile>, void> print_func(this, &SimpleAudio::print);
    ConstFunctor<SimpleAudio, Simplefile, std::string> rep_func(this, &SimpleAudio::get_name_from_file);

    int *position;
    if (mode == ADD)
      position = &folders.top().second;
    else
      position = &playlist_pos_int;

    input_master->device->search(*files, position, &print_func, &compare_func, &rep_func, 
				 search_mode, search_str, lowercase_search_str, offset);
  }

  void page_up();
  void page_down();

public:
  void read_dirs();

  std::string get_name_from_file(const Simplefile& d);
  std::string get_short_name_from_file(const Simplefile& d);

  std::string mainloop(AudioMode mode);
  
  void print(const std::vector<Simplefile>& files);
};

#endif
