#include "gsimplefile.hpp"

#include "libfspp.hpp"
#include "config.hpp"
#include "common.hpp"

#include <vector>

using std::string;
using std::vector;

GSimplefile::GSimplefile(const Simplefile s)
  : Simplefile(s)
{}

GSimplefile::GSimplefile()
{}

string GSimplefile::find_cover_in_current_dir() const
{
  if (path.empty())
    return "";

  Config *conf = S_Config::get_instance();

  string pic = "";

  vector<string> pictures_found;

  MyPair filetype;

  string::size_type pos;

  if ((pos = path.rfind("/")) != string::npos) {
    string folder = path.substr(0, pos);
  
    // determine if there is a picture in this dir...
    for (file_iterator<file_t, default_order> i (folder); i != i.end (); i.advance(false))
      if (check_type(i->getName(), conf->p_filetypes_p()) != emptyMyPair)
	pictures_found.push_back(i->getName());

    if (!pictures_found.empty()) {
      pic = pictures_found.front();
      for (vector<string>::iterator iter = pictures_found.begin(); iter 
	     != pictures_found.end(); ++iter) {
	string filename = string_format::lowercase(*iter);
	if (filename.rfind("front") != string::npos) {
	  pic = *iter;
	  break;
	}
      }
    }
  }

  return pic;
}

