#ifndef GUIBUTTONCONTROL_HPP
#define GUIBUTTONCONTROL_HPP

#include "guicontrol.hpp"
#include "guilabelcontrol.hpp"
#include "guiimagecontrol.hpp"
#include <string>

namespace pymms {

namespace gui {

class GUIButtonControl : public GUIControl
{
  protected:
    std::string text, font, rgb, rgbfocus, alignment;
    std::string image_focus, image_nofocus;
    int textoffset;
    int cutoff;

  public:
    GUIButtonControl(int x, int y, int w, int h, std::string t, int l, std::string foc, std::string nofoc, 
		     std::string f="Vera", std::string rgb="0xffffff", std::string rgbfocus="0xffffff", 
		     int tos=0, std::string alig="left", int cutoff=0);
    std::string get_label();
    void set_label(std::string t);
    void set_labelfont(std::string f);
    void set_labelrgb(std::string rgb);
    void set_labelrgbfocus(std::string rgbfocus);
    void render();
};

}

}

#endif
