#ifndef GUICONTROL_HPP
#define GUICONTROL_HPP

#include <string>
#include <cc++/thread.h>

namespace pymms {

namespace gui {

class GUIControl
{
  protected:
    int x, y, width, height, layer, id, parent_id;
    bool focus, visible;
    GUIControl *right, *left, *next, *prev;
    ost::Mutex guicontrol_mutex;
    GUIControl(int x, int y, int w, int h, int l);
    void on_right();
    void on_left();
    void on_prev();
    void on_next();
    
  public:
    virtual bool on_action(std::string action);
    virtual void render() = 0;
    virtual void free_resources();
    void control_left(GUIControl* l);
    void control_right(GUIControl* r);
    void control_prev(GUIControl* p);
    void control_next(GUIControl* n);
    void set_focus(bool f);
    bool get_focus();
    void set_visible(bool v);
    bool get_visible();
    void set_height(int h);
    int get_height();
    void set_width(int h);
    int get_width();
    void set_layer(int h);
    int get_layer();
    void set_id(int id);
    int get_id();
    void set_parent_id(int id);
    int get_parent_id();
    void set_position(int x, int y);
    void reset();
};
    
}

}

#endif
