#ifndef GUILABELCONTROL_HPP
#define GUILABELCONTROL_HPP

#include "guicontrol.hpp"
#include "renderer.hpp"
#include <string>

namespace pymms {

namespace gui {

class GUILabelControl : public GUIControl
{
  protected:
    std::string text, font, rgb, alignment;
    int r, g, b, font_size, textoffset;
    std::pair<int, int> real_size;
    Render *renderer;

    void hex_to_rgb();
    void calc_font_size();

  public:
    GUILabelControl(int x, int y, int w, int h, std::string t, int l, 
		    std::string f="Vera", std::string rgb="0xffffff", 
		    int tos=0, std::string alig="left");
    std::string get_label();
    void set_label(std::string t);
    void set_labelfont(std::string f);
    void set_labelrgb(std::string rgb);
    int get_realwidth();
    int get_realheight();
    void render();
};

}

}

#endif
