#ifndef GUITEXTBOXCONTROL_HPP
#define GUITEXTBOXCONTROL_HPP

#include "guicontrol.hpp"
#include <string>
#include <vector>

namespace pymms {

namespace gui {

class GUITextBoxControl : public GUIControl
{
  protected:
    std::string font, rgb, alignment, text;
    int itemheight, itemspace, pos, font_size;
    std::vector<std::string> items; 

    void calc_font_size();
    void split_text();

  public:
    GUITextBoxControl(int x, int y, int w, int h, int l, std::string f="Vera", 
		   std::string rgb="0xffffff", int itemh=30, int itemsp=0);
    ~GUITextBoxControl();
    void set_textfont(std::string f);
    void set_textrgb(std::string rgb);
    void set_text(std::string t);
    void set_textheight(int th);
    void set_textspace(int ts);
    void clear();
    bool on_action(std::string action);
    void render();
};

}

}

#endif
