#ifndef GUIWINDOW_HPP
#define GUIWINDOW_HPP

#include <vector>
#include <list>
#include <cc++/thread.h>
#include "config.hpp"
#include "guicontrol.hpp"

namespace pymms {

namespace gui {

class GUIWindow
{
  protected:
    Config *config;
    std::vector<GUIControl*> controls;
    int control_id;
    int window_id;
    ost::Mutex guiwindow_mutex;

  public:
    GUIWindow();
    virtual ~GUIWindow();
    virtual bool on_action(std::string action);
    bool add_control(GUIControl* c);
    int get_id();
    void set_id(int id);
    bool set_focus(GUIControl *c);
    GUIControl *get_focus();
    int get_width();
    int get_height();
    bool remove_control(GUIControl *c);
    void render();
};

}

}

#endif
