#ifndef GUIWINDOWMANAGER_HPP
#define GUIWINDOWMANAGER_HPP

#include <cc++/thread.h>
#include "singleton.hpp"
#include "renderer.hpp"

#include "guiwindow.hpp"

#include <list>

namespace pymms {

namespace gui {

class GUIWindowManager
{
  private:
    Render *renderer;
    ost::Mutex guiwindowmanager_mutex;
    std::list<GUIWindow*> windows;
  
  public:
    GUIWindowManager();
    bool on_action(std::string action);
    void register_window(GUIWindow *window);
    void unregister_window(GUIWindow *window);
    void set_active_window(GUIWindow *window);
    void set_active_window(int id);
    GUIWindow *get_active_window();
    GUIWindow *get_window(int id);
    void render();
    void render(int id);
};

typedef Singleton<GUIWindowManager> S_WindowManager;

}

}

#endif
