#include "gui/guirectanglecontrol.hpp"
#include "rectangle_object.hpp"

pymms::gui::GUIRectangleControl::GUIRectangleControl(int x, int y, int w, int h, int l, 
				int alpha, std::string rgb) : GUIControl(x, y, w, h, l)
{
  r = g = b = 0;
  this->alpha = (alpha>=0)?alpha:0;
  this->rgb = rgb;
  renderer = S_Render::get_instance();
}

void pymms::gui::GUIRectangleControl::hex_to_rgb()
{
  int hexrgb;

  sscanf(rgb.c_str(), "%x", &hexrgb);
  r = (hexrgb & 0xff0000) >> 16;
  g = (hexrgb & 0x00ff00) >> 8;
  b = hexrgb & 0x0000ff;
}

void pymms::gui::GUIRectangleControl::set_rgb(std::string rgb)
{
  ost::MutexLock lock(guicontrol_mutex);
  this->rgb = rgb;
}

void pymms::gui::GUIRectangleControl::set_alpha(int alpha)
{
  ost::MutexLock lock(guicontrol_mutex);
  this->alpha = (alpha>=0)?alpha:0;
}

void pymms::gui::GUIRectangleControl::render()
{
  ost::MutexLock lock(guicontrol_mutex);
  hex_to_rgb();

  renderer->current.add(new RObj(x, y, width, height, r, g, b, alpha, layer));
}  
