#ifndef GUIWINDOWSCRIPTLAUNCHER_HPP
#define GUIWINDOWSCRIPTLAUNCHER_HPP

#include "config.hpp"
#include "simplefile.hpp"

#include "gui/guiwindow.hpp"
#include "gui/guirectanglecontrol.hpp"
#include "gui/guilistcontrol.hpp"
#include "gui/guiimagecontrol.hpp"
#include "gui/guilabelcontrol.hpp"
#include "gui/guilistitem.hpp"

#include <string>
#include <vector>
#include <list>

using namespace pymms::gui;

class SLItem : public GUIListItem
{
  private:
    Simplefile fileinfo;

  public:
    SLItem(Simplefile fi)
    {
      fileinfo = fi;
      set_label(fi.name);
      set_label2(fi.type);
    }

    Simplefile get_fileinfo()
    {
      return fileinfo;
    }
};

class GUIWindowScriptLauncher : public GUIWindow
{
  private:
    std::list<std::string> dirs;
    GUIListControl *list;

    Config *conf;
    std::vector<Simplefile> rdir(const std::string& argv);
    Simplefile addsimplefile(const std::string& name, const MyPair& filetype, bool from_media = false);
    void read_dir(std::string path);

  public: 
    GUIWindowScriptLauncher(std::string startdir);
    ~GUIWindowScriptLauncher();
    bool on_action(std::string a);
};
    
#endif

