#include <Python.h>
#include "structmember.h"
#include "pyaudioplayer.hpp"
#include "pyvideoplayer.hpp"

#ifdef __cplusplus
extern "C" {
#endif

namespace pymms {

namespace python {

static PyMethodDef module_methods[] = {
    {NULL}  /* Sentinel */
};

#ifndef PyMODINIT_FUNC
#define PyMODINIT_FUNC void
#endif
PyMODINIT_FUNC
initmmsv2(void)
{
  PyObject* mmsv2module;

  if (PyType_Ready(&PyAPlayer_Type) < 0)
    return;

  if (PyType_Ready(&PyVPlayer_Type) < 0)
    return;

  mmsv2module = Py_InitModule3("mmsv2", module_methods, "mmsv2 objects");

  if (mmsv2module == NULL)
    return;

  Py_INCREF(&PyAPlayer_Type);
  Py_INCREF(&PyVPlayer_Type);

  PyModule_AddObject(mmsv2module, "AudioPlayer", (PyObject *)&PyAPlayer_Type);
  PyModule_AddObject(mmsv2module, "VideoPlayer", (PyObject *)&PyVPlayer_Type);
}

}

}

#ifdef __cplusplus
}
#endif


