#include "guiwindowdialogprogress.hpp"
#include "gui/guiwindowmanager.hpp"
#include "gui/guiimagecontrol.hpp"

pymms::gui::GUIWindowDialogProgress::GUIWindowDialogProgress(std::string h, std::string l1, 
							std::string l2, std::string l3) : GUIWindowDialog(h, l1, l2, l3)
{
  window_id = 503;

  current_percent = 0;
  isCanceled = false;

  cancelButton = new GUIButtonControl(get_width()/2-256+512-70-65, get_height()/2-108+22+30+25+25+35, 100, 25, 
				"Cancel", 3, "python/button-focus.png", "python/button-nofocus.png", "Vera", "0xffffff", "0xffffff", 0, "center");
  add_control(cancelButton);

  add_control(new GUIImageControl(get_width()/2-256+61,
                        get_height()/2-108+22+30+25+25+35+5, 302, 15, "python/progress_over.png", 4));

  set_focus(cancelButton);
}

pymms::gui::GUIWindowDialogProgress::~GUIWindowDialogProgress()
{
}

bool pymms::gui::GUIWindowDialogProgress::on_action(std::string action)
{
  if(action == "action")
    if( (get_focus() == cancelButton) && !isCanceled)
    {
      isCanceled = true;
      header->set_label(header->get_label() + " (Aborting...)");
    }

  S_WindowManager::get_instance()->render();

  return true;
}

bool pymms::gui::GUIWindowDialogProgress::is_canceled()
{
  return isCanceled;
}

void pymms::gui::GUIWindowDialogProgress::update(int percent)
{
  if( (percent > 0) && (percent <= 100) && (current_percent < 30*percent/100) )
  {
    for(current_percent; current_percent < 30*percent/100; current_percent++)
    {
      add_control(new GUIImageControl(get_width()/2-256+61 + current_percent*10,
                        get_height()/2-108+22+30+25+25+35+5, 12, 15, "general/progress.png", 3));

     S_WindowManager::get_instance()->render();
    }

  }
}
