#include <Python.h>
#include "structmember.h"
#include "pycontrol.hpp"
#include "pywindow.hpp"
#include "pywindowdialog.hpp"

#ifdef __cplusplus
extern "C" {
#endif

namespace pymms {

namespace python {

static PyMethodDef module_methods[] = {
    {NULL}  /* Sentinel */
};

#ifndef PyMODINIT_FUNC
#define PyMODINIT_FUNC void
#endif
PyMODINIT_FUNC
initmmsv2gui(void)
{
  PyObject* mmsv2guimodule;

  if (PyType_Ready(&Control_Type) < 0)
    return;

  if (PyType_Ready(&ImageControl_Type) < 0)
    return;

  if (PyType_Ready(&LabelControl_Type) < 0)
    return;

  if (PyType_Ready(&ButtonControl_Type) < 0)
    return;

  if (PyType_Ready(&ListControl_Type) < 0)
    return;

  if (PyType_Ready(&TextBoxControl_Type) < 0)
    return;

  if (PyType_Ready(&RectangleControl_Type) < 0)
    return;

  if (PyType_Ready(&Window_Type) < 0)
    return;

  if (PyType_Ready(&Dialog_Type) < 0)
    return;

  if (PyType_Ready(&DialogProgress_Type) < 0)
    return;
 
  if (PyType_Ready(&ListItem_Type) < 0)
    return;
  
  mmsv2guimodule = Py_InitModule3("mmsv2gui", module_methods, "mmsv2gui objects");

  if (mmsv2guimodule == NULL)
    return;

  Py_INCREF(&Control_Type);
  Py_INCREF(&ImageControl_Type);
  Py_INCREF(&LabelControl_Type);
  Py_INCREF(&ButtonControl_Type);
  Py_INCREF(&ListControl_Type);
  Py_INCREF(&TextBoxControl_Type);
  Py_INCREF(&RectangleControl_Type);
  Py_INCREF(&Window_Type);
  Py_INCREF(&Dialog_Type);
  Py_INCREF(&DialogProgress_Type);
  Py_INCREF(&ListItem_Type);

  PyModule_AddObject(mmsv2guimodule, "Control", (PyObject *)&Control_Type);
  PyModule_AddObject(mmsv2guimodule, "ImageControl", (PyObject *)&ImageControl_Type);
  PyModule_AddObject(mmsv2guimodule, "LabelControl", (PyObject *)&LabelControl_Type);
  PyModule_AddObject(mmsv2guimodule, "ButtonControl", (PyObject *)&ButtonControl_Type);
  PyModule_AddObject(mmsv2guimodule, "ListControl", (PyObject *)&ListControl_Type);
  PyModule_AddObject(mmsv2guimodule, "TextBoxControl", (PyObject *)&TextBoxControl_Type);
  PyModule_AddObject(mmsv2guimodule, "RectangleControl", (PyObject *)&RectangleControl_Type);
  PyModule_AddObject(mmsv2guimodule, "Window", (PyObject *)&Window_Type);
  PyModule_AddObject(mmsv2guimodule, "Dialog", (PyObject *)&Dialog_Type);
  PyModule_AddObject(mmsv2guimodule, "DialogProgress", (PyObject *)&DialogProgress_Type);
  PyModule_AddObject(mmsv2guimodule, "ListItem", (PyObject *)&ListItem_Type);
}

}

}

#ifdef __cplusplus
}
#endif


