#ifndef PYTHON_HPP
#define PYTHON_HPP

#include "module.hpp"
#include "options.hpp"
#include "singleton.hpp"

#include "guiwindowscriptlauncher.hpp"

#include <vector>
#include <string>

class Python : public Module 
{
private:
  
  class PythonOpts : public Options 
  {
  public:
    PythonOpts();
    ~PythonOpts();

    std::vector<Option*> values() 
    {
      return val;
    }
 
  private:
    Option *reload_u;

    void read_dirs();
  };
  
  GUIWindowScriptLauncher *slwindow;

  PythonOpts opts;

public:
  Python();
  ~Python();

  PythonOpts* get_opts()
  {
    return &opts;
  }
  
  void startup_updater();
  std::string mainloop();
};

#endif
