#include "python.hpp"
#include "plugin.hpp"

#include "common-feature.hpp"

#include "python_config.hpp"

void python_exec()
{
  get_class<Python>("Python")->mainloop();
}

class PythonPlugin : public FeaturePlugin
{
public:
  PythonPlugin() 
  {
    Config *conf = S_Config::get_instance();
    PythonConfig *python_conf = S_PythonConfig::get_instance();

    python_conf->parse_configuration_file(conf->p_homedir());

    module = new Python();
    features.push_back(startmenu_item(gettext("Run python script"), "python", "python/script.png", 0, VoidFunctor(&python_exec)));  
  }

  std::string plugin_name() const { return gettext("Scripts"); }
  int priority() const { return 3; }
  unsigned long capability() const { return 0; }

};

MMS_PLUGIN(PythonPlugin)
