#include "plugin.hpp"
#include "themes.hpp"
#include "config.hpp"
#include "common-feature.hpp"
#include "tv.hpp"
#include "tv_config.hpp"

void tv()
{
  Tv *tv = get_class<Tv>("TV");
  tv->mainloop();
}

class TVPlugin : public FeaturePlugin
{
public:
  TVPlugin() {
    Themes *themes = S_Themes::get_instance();

    TVConfig *tv_conf = S_TVConfig::get_instance();
    Config *conf = S_Config::get_instance();

    tv_conf->parse_configuration_file(conf->p_homedir());

    module = new Tv();

    features.push_back(startmenu_item(gettext("Watch TV"), "tv", themes->startmenu_tv, 
				      0, VoidFunctor(&tv)));
  }

  std::string plugin_name() const { return gettext("TV"); }
  int priority() const { return 3; }
  unsigned long capability() const { return 0; }
};

MMS_PLUGIN(TVPlugin)
