#ifndef DXR3OUT_HPP
#define DXR3OUT_HPP

#include "render_device.hpp"
#include "mpeg.hpp"
#include "dxr3_config.hpp"

class Dxr3 : public RenderDevice
{
private:
  mpeg_frame iframe;

  int fd_control;
  int fd_video;
  int initialized;

  bool locked;

  ost::Mutex locked_mutex;

  Dxr3Config *dxr3_conf;

public:

  Dxr3();

  void init();
  void deinit();
  
  void redraw();

  void lock();
  void unlock();

  bool supports_wid() { return false; }

  void show_window_video() {};
  void hide_window_video() {};

  void show_fs_video() {};
  void hide_fs_video() {};

  void hide_video() {};

 private:
  void run();
};

#endif
